module.exports.__fsLocationMap = [[4, 14, 3, 16], [4, 8, 3, 24], [4, 14, 3, 30], [5, 5, 4, 3], [5, 22, 4, 16], [5, 34, 4, 24], [5, 22, 5, 63], [5, 34, 6, 63], [5, 34, 7, 5], [5, 34, 7, 14], [6, 9, 8, 5], [6, 14, 8, 10], [8, 5, 11, 3], [8, 14, 11, 8], [8, 23, 11, 13], [9, 9, 12, 5], [9, 12, 12, 9], [9, 19, 12, 16], [9, 27, 12, 24], [10, 13, 13, 7], [10, 18, 13, 12], [10, 23, 13, 17], [10, 30, 13, 24], [11, 9, 14, 12], [11, 14, 14, 16], [11, 21, 14, 23], [11, 29, 14, 31], [12, 13, 15, 7], [12, 18, 15, 12], [12, 25, 15, 19], [14, 5, 19, 3], [14, 14, 19, 8], [14, 14, 20, 63], [15, 9, 21, 5], [15, 16, 21, 12], [15, 21, 21, 17], [15, 26, 21, 22]];
module.exports.__esModule = true;
const FirescriptRuntime = require('firescript-runtime').FirescriptRuntime;
module.exports.Model = class Model {
  constructor (schema, config) {
    FirescriptRuntime.paramTyping(FirescriptRuntime.TYPE_OBJ, schema, 'schema');
    FirescriptRuntime.paramTyping(FirescriptRuntime.TYPE_OBJ, config, 'config');
    config = config || {};
    this.data = {};
  }

  set (key, value) {
    if (typeof key === 'string') {
      this.data[key] = value;
    } else if (typeof key === 'object') {
      this.data = value;
    }
  }

  get (key) {
    FirescriptRuntime.paramTyping(FirescriptRuntime.TYPE_STR, key, 'key');
    return this.data[key];
  }
};
