module.exports.__fsLocationMap = [[1, 14, 3, 16], [1, 8, 3, 23], [1, 14, 3, 29], [2, 5, 4, 3], [2, 18, 4, 16], [2, 18, 5, 5], [2, 18, 5, 12], [3, 9, 6, 5], [3, 14, 6, 10], [3, 22, 6, 18], [3, 27, 6, 23], [3, 36, 6, 32], [4, 9, 7, 5], [4, 14, 7, 10], [4, 21, 7, 17], [5, 9, 8, 5], [5, 14, 8, 10], [5, 28, 8, 24], [14, 5, 18, 3], [14, 15, 18, 9], [14, 15, 19, 63], [15, 9, 20, 5], [15, 14, 20, 10], [15, 28, 20, 24], [16, 9, 21, 5], [16, 16, 21, 12], [23, 5, 29, 3], [24, 9, 30, 5], [24, 15, 30, 11], [24, 25, 30, 21], [25, 9, 31, 5], [25, 15, 31, 11], [25, 24, 31, 20], [26, 9, 32, 5], [26, 15, 32, 11], [26, 22, 32, 18], [26, 27, 32, 23], [28, 9, 33, 5], [28, 16, 33, 12], [28, 31, 33, 27], [28, 41, 33, 37], [28, 63, 33, 59]];
module.exports.__esModule = true;
const FirescriptRuntime = require('firescript-runtime').FirescriptRuntime;
module.exports.Page = class Page {
  constructor (opts) {
    opts = opts || {};
    this.title = opts.title || 'Blank page';
    this.tick = 0;
    this.pageContent = '';
  }

  /**
      * Set page content, overwrites existing content
      *
      * @method {html}
      * @param {str} pageContent
      * @returns Instance of Page
      */
  html (pageContent) {
    FirescriptRuntime.paramTyping(FirescriptRuntime.TYPE_STR, pageContent, 'pageContent');
    this.pageContent = pageContent;
    return this;
  }

  /**
      * Render page
      *
      * @returns Rendered page as html string
      */
  render () {
    const scripts = '';
    const styles = '';
    const body = this.pageContent;
    return `<html><head>${scripts}${styles}</head><body>${body}</body></html>`;
  }
};
