module.exports.__fsLocationMap = [[1, 8, 2, 7], [1, 26, 2, 30], [1, 8, 2, 38], [2, 13, 3, 7], [2, 25, 3, 24], [3, 8, 4, 7], [3, 23, 4, 27], [3, 8, 4, 39], [5, 1, 5, 1], [5, 7, 5, 7], [5, 16, 5, 16], [5, 26, 5, 26], [7, 1, 6, 1], [7, 7, 6, 7], [8, 1, 7, 1], [8, 7, 7, 7], [10, 14, 8, 16], [10, 8, 8, 31], [10, 14, 8, 37], [11, 5, 9, 3], [11, 18, 9, 16], [11, 18, 10, 5], [11, 18, 10, 12], [12, 9, 11, 5], [12, 14, 11, 10], [12, 21, 11, 17], [12, 26, 11, 22], [12, 34, 11, 30], [13, 9, 12, 5], [13, 14, 12, 10], [13, 21, 12, 17], [13, 26, 12, 22], [13, 34, 12, 30], [14, 9, 13, 5], [14, 14, 13, 10], [14, 21, 13, 17], [14, 26, 13, 22], [14, 34, 13, 30], [15, 9, 14, 5], [15, 14, 14, 10], [15, 24, 14, 20], [15, 29, 14, 25], [15, 40, 14, 36], [17, 9, 15, 5], [17, 12, 15, 9], [17, 13, 15, 10], [17, 18, 15, 15], [18, 13, 16, 7], [18, 19, 16, 13], [18, 23, 16, 17], [18, 29, 16, 23], [20, 9, 18, 5], [20, 14, 18, 10], [20, 25, 18, 21], [20, 30, 18, 26], [22, 5, 21, 3], [23, 9, 22, 5], [23, 12, 22, 9], [23, 13, 22, 10], [23, 35, 22, 32], [23, 38, 22, 35], [23, 43, 22, 40], [23, 51, 22, 48], [23, 56, 22, 53], [24, 13, 23, 7], [24, 19, 23, 13], [24, 34, 23, 28], [24, 41, 23, 35], [26, 13, 24, 7], [26, 26, 24, 20], [26, 40, 24, 34], [27, 13, 25, 7], [27, 26, 25, 20], [30, 13, 27, 7], [30, 19, 27, 13], [30, 28, 27, 22], [31, 13, 28, 7], [31, 20, 28, 14], [31, 27, 28, 21], [31, 32, 28, 26], [31, 38, 28, 32], [31, 43, 28, 37], [72, 9, 60, 5], [72, 16, 60, 12], [72, 38, 60, 34], [72, 41, 60, 37], [72, 46, 60, 42], [72, 54, 60, 50], [72, 59, 60, 55]];
module.exports.__esModule = true;
const createServer = require('http').createServer;
const SockJS = require('sockjs');
const getLogger = require('logtopus').getLogger;
const logger = getLogger('fireio:socket');
const socketServerInstances = {};
const socketChannels = {};
module.exports.SocketServer = class SocketServer {
  constructor (opts) {
    opts = opts || {};
    this.port = opts.port || 9889;
    this.host = opts.host || '127.0.0.1';
    this.path = opts.path || 'fireio-socket';
    this.channel = opts.channel || 'test';
    if (!this.channel) {
      throw new Error('No channel was set!');
    }
    this.__socket = this.getSocketServer();
  }

  getSocketServer () {
    if (!socketServerInstances[`${this.host}:${this.port}`]) {
      const socketServer = SockJS.createServer();
      socketServer.connections = [  ];
      socketServer.channels = {};
      // TODO share server instances
      const server = createServer();
      server.listen(this.port, this.host);
      //const prefix = this.path.replace(/^\//, 'nn')
      //socketServer.installHandlers(server, {
      //    prefix: prefix
      //  })
      //socketServer.on('connection', (conn) =>
      //  logger.sys('New connection', conn.id, conn.pathname)
      //  socketServerInstances['${this.host}:${this.port}'].connections.push(conn)
      //  conn.on('data', (msg) =>
      //    msg = JSON.parse(msg)
      //    logger.req('Got socket message ' + conn.pathname + ' @ ' + msg.channel + ' : ' + msg.eventName, msg.args)
      //    const args = msg.args || []
      //    args.unshift(msg.eventName)
      //    args.push(conn)
      //    if !socketServer.channels.hasOwnProperty(msg.channel)
      //      logger.warn('Channel ' + msg.channel + ' is not registered!')
      //      return
      //    socketServer.channels[msg.channel].emit.apply(socketServer.channels[msg.channel], args)
      //  )
      //  conn.on('close', (err) =>
      //    logger.sys('Close socket connection', err)
      //    const len = socketServerInstances['${this.host}:${this.port}'].connections.length
      //    for i = 0; i < len; i++
      //      if socketServerInstances['${this.host}:${this.port}'].connections[i] === conn
      //        socketServerInstances['${this.host}:${this.port}'].connections.splice(i, 1)
      //        break
      //    if socketServer.monitoring
      //      socketServer.monitoring.emit('client.disconnect')
      //  if (socketServer.monitoring) {
      //    socketServer.monitoring.emit('client.connect')
      //socketServerInstances['${this.host}:${this.port}'] = socketServer
    }
    return socketServerInstances[`${this.host}:${this.port}`];
  }
};
